data(CO2)
str(CO2)
library(tidyverse)
library(pander)

lm(uptake~conc+Type+Treatment,data=CO2)%>%summary()

lm(uptake~conc+Type*Treatment,data=CO2)%>%summary()

lm(uptake~conc+Type*Treatment,data=CO2)%>%plot()

lm1<-lm(uptake~conc+Type+Treatment,data=CO2)
lm2<-lm(uptake~conc+Type*Treatment,data=CO2)

lm3<-lm(uptake~conc+Type:Treatment,data=CO2)

AIC(lm1,lm2,lm3)

BIC(lm1,lm2,lm3)


lm4<-lm(uptake~conc*Type+Treatment,data=CO2)

install.packages("MASS")
library(MASS)
full.model<-lm(uptake~.,data=CO2)
stepAIC(full.model,trace=1,direction="both")

full.model2<-lm(uptake~conc+Treatment*Type,data=CO2)
stepAIC(full.model2,trace=1,direction="both")


anova(lm2)

loess(uptake~conc,data=CO2)%>%summary()

ggplot(CO2,aes(x=conc,y=uptake,col=Type))+geom_point()+geom_smooth(method="loess")+
  facet_grid(.~Treatment)
  


loess(uptake~conc,data=CO2)%>%plot()

glm(uptake~conc+Treatment+Type,data=CO2,family=poisson)
glm(uptake~conc+Treatment+Type,data=CO2,family=binomial)

gam()
#gam
#mgcv()
gam(uptake~s(conc)+Treatment+Type,data=CO2,family=binomial)




