#######################################
##INTRODUCCIÓN A LA ESTADÍSTICA CON R #
#######################################

install.packages("vcd")
library(vcd)

fir<-read.table("fir.txt",header = TRUE)
frogs<-read.table("frogs.txt",header=TRUE)
str(fir)
str(frogs)

ggplot(fir,aes(x=DBH))+geom_histogram()
ggplot(fir,aes(x=conos))+geom_histogram()
ggplot(fir,aes(x=crecimiento))+geom_histogram()

shapiro.test(fir$DBH)
shapiro.test(fir$conos)
shapiro.test(fir$crecimiento)

data("iris")
shapiro.test(iris$Sepal.Width)
ggplot(iris,aes(x=Sepal.Width))+geom_histogram(bins=20)
ggplot(iris,aes(x=Sepal.Width))+geom_density()
shapiro.test(iris$Petal.Width)
ggplot(iris,aes(x=Petal.Width))+geom_histogram(bins=20)
ggplot(iris,aes(x=Petal.Width))+geom_density()+facet_grid(.~Species)


str(frogs)
shapiro.test(frogs$surv)
ggplot(frogs,aes(x=surv))+geom_histogram(bins=10)
ggplot(frogs,aes(x=surv))+geom_density()
goodfit(frogs$surv,type="poisson")%>%
  summary()
goodfit(frogs$surv,type="nbinomial")%>%
  summary()

biocrust<-read.table("biocrust.txt")
str(biocrust)
shapiro.test(biocrust$Tmean)
shapiro.test(biocrust$Tmean[1:4999])
ggplot(biocrust,aes(x=Tmean))+geom_histogram()

rnorm(nrow(biocrust),mean=mean(biocrust$Tmean),sd=sd(biocrust$Tmean))%>%
  as.data.frame()%>%
  ggplot(aes(x=.))+
  geom_histogram()+
  geom_histogram(data=biocrust,aes(x=Tmean,fill="red",alpha=0.6))+theme_bw()+
  theme(legend.position="NONE")

data(CO2)
?CO2
ggplot(CO2,aes(x=uptake))+geom_density()

ggplot(CO2,aes(x=uptake))+geom_density()+
  facet_grid(.~Type)

ggplot(CO2,aes(x=uptake))+geom_density()+
  facet_grid(.~Treatment)

ggplot(CO2,aes(x=uptake))+geom_density()+
  facet_grid(Type~Treatment)
