################################################################################

#  Taller GBIF.ES: Manejo, visualizacin y anlisis de datos en ecologa con R
# Code by: Julia Chacn Labella
# Date: November 2018
# email: chacon.julia@inia.es
# Tema 4: Manipulacin de objetos

#############################################################################
# Funciones paste() rbind() cbind() merge
############################################################################

data(iris)

################
## UNIR DATOS
################

##   la funcion paste () para pegar dos vectores

x <- c("a", "b", "c", "d")
y <- c("A", "B", "C", "D")

paste(x,y)
paste(x,y, sep="_")
paste(x,y, sep=".")
paste(x,y, sep=" ") # por defecto

##   rbind() y cbind()

# vamos a unir el data frame IRIS con otro data frame
# genero dos columnas nuevas, color y ao

color <-  as.factor(rep(c("azul", "morado", "blanco"), times=50))
ao <- as.factor(rep(c(2008,2009,2010), times=50))

## hago un data frame que se llama nuevas.columnas

nuevas.columnas <- data.frame(color, ao)
head(nuevas.columnas)

##  la funcion cbind une dos data frames por columnas
#   han de tener misma longitud de filas. Si no, no se pueden unir
dim(iris)
dim(nuevas.columnas)

iris.col <- cbind(iris, nuevas.columnas) # nuevo data frame
dim(iris.col)

###### rbind ()

head(iris)

nf1 <- c(10,10,10,10,"setosa")
nf2 <-c(100,100,100,100,"setosa")
nf3 <- c(1,1,1,1,"setosa")

## la funcion rbind une dos data frames por filas
# han de tener misma longitud de columnas. Si no no se pueden unir

iris.filas <- rbind(iris, nf1) # nuevo data frame
dim(iris.filas)

#############
# tambin podemos hacer un data frame con nf1, nf2, nf3

rbind(nf1, nf2, nf3)#pego las tres buevas filas seguidas
nuevas.filas <- data.frame(rbind(nf1, nf2, nf3))
nuevas.filas

iris.filas <- rbind(iris, nuevas.filas) 
#nos da un error

colnames(nuevas.filas)
colnames(iris)

colnames(nuevas.filas) <- colnames(iris)

iris.filas <- rbind(iris, nuevas.filas) 

##   CRUCES DE TABLAS
##   merge() 
# une dos data frames por un campo en comn
# usa un campo en comn por defecto
# si solo hay uno no hay que especificar nada
# si hay varios campos en comn habra que especificarlos

# generamos dos data frame nuevos a partir de los cuales crear una nueva tabla


especies <- data.frame(id = 1:3, nombre = c("Betula", "Quercus", "Abies"))

dimensiones <- data.frame(id = c(1, 1, 1, 2, 2, 3, 3, 3, 1), 
                          altura = c(3,2,9,12,13, 5, 10, 13, 3), 
                          diam = 100 * runif(9))
especies
dimensiones

merge(especies, dimensiones)
merge(especies, dimensiones, by="id")

## La funcin merge genera una nueva tabla que es una combinacin de las otras dos

## comprueba qu ocurre en el siguiente ejemplo
dim2 <- data.frame(id = c( 2, 2, 3, 3, 3), 
                   altura = c(5, 10, 13, 3, 9), 
                   diam = 100 * runif(5))
dim2
especies

merge(especies, dim2)
merge(especies, dim2, all.x = TRUE)


