################################################################################

#  Taller GBIF.ES: Manejo, visualizacin y anlisis de datos en ecologa con R
# Code by: Julia Chacn Labella
# Date: November 2018
# email: chacon.julia@inia.es
# Tema 4: Manipulacin de objetos

#############################################################################
# Transformaciones de los data frames
############################################################################
# notacin de corchetes para acceso a datos de una lista o data frame
# la funcin subset()
# la funcin which() 
# CREAR/ELIMINAR COLUMNAS en un data frame
############################################################################

mi.lista <- list(a = 1:3, b = c("quercus","betula", "abies"))
mi.lista$c <- matrix(1:4, 2, 2)
mi.lista$x <- lm(Petal.Length~Petal.Width, data=iris) 
mi.lista$i <- iris
mi.lista$i <- NULL
mi.lista

mi.lista <- vector(mode="list", length=10) #esta funcion genera un vector
# de una longitud determinada y un modo concreto. Puede ser una lista. 

# Acceso a los datos de un data frame con corchetes
iris[1:15,]        # acceso a las 15 primeras filas
iris[, 3:4]        # columnas de la 3 a la 4
iris[1:15, 3:4]   # acceso a un dato concreto

iris.setosa <- iris[iris$Species == "setosa",] # datos de iris, cuando la specie es setosa

iris.virginica.7 <-  iris[iris$Sepal.Length > 7 & iris$Species == "virginica",]

# datos de iris, cuando la specie es virginica y ancho del sepalo es mayor a 6

# La funcin subset()
head(airquality)

air.subs <- subset(airquality, Temp > 80, select = c(Ozone, Temp))

air.subs2 <- subset(airquality, Day == 1, select = -Temp)

air.subs3 <- subset(airquality, select = Ozone:Wind)

head(iris)
iris.subs1 <- subset(iris, Sepal.Width > 3.9, select = c(Sepal.Length, Species))
iris.subs1
iris.subs2 <- subset(iris, Sepal.Width == 3.5, select = c(Sepal.Width:Species))
iris.subs2 

# funcin which() 

iris[which(iris$Sepal.Width >3.9),]
subset(iris, Sepal.Width > 3.9)
iris[iris$Sepal.Width>3.9,]

iris.subs11 <- iris[which(iris$Sepal.Width > 3.9),][,c(1,5)]
iris.subs11

iris.subs22 <- iris[which(iris$Sepal.Width == 3.5),][,c(2:5)]
iris.subs22


# EJEMPLO: DOS FORMAS DE DECIR LO MISMO
dim(iris[which(iris$Sepal.Width > 3.9),])

dim(iris[iris$Sepal.Width > 3.9,])


# CREAR/ELIMINAR COLUMNAS en un data frame

color = rep(c("rosa", "blanco", "morado"), times=50) #  longitud 150

iris$color <- color
head(iris)

iris$color <- NULL #para eliminarla
head(iris)

iris <- cbind(iris, color)
head(iris)

iris$nuevacol <- iris$Sepal.Length/iris$Sepal.Width
head(iris)

iris$nuevacol <- NULL #para eliminarla
head(iris)


