################################################################################

#  Taller GBIF.ES: Manejo, visualizacin y anlisis de datos en ecologa con R
# Code by: Julia Chacn Labella
# Date: November 2018
# email: chacon.julia@inia.es

################################################################################


# Antes de comenzar a ver qu son los objetos y funciones haremos una breve 
# introduccin a los vectores

#########################
# VECTORES 
#########################

# Si os fijais cualquier operacin que hacemos presenta un [1] entre corchetes
# delante. Esto sera un vector de un solo elemento. Podemos construir vectores 
# ms grandes de la siguiente forma

c(0,1,2,3,4,5)

# es una secuencia de numeros en un orden determinado
# podemos decirle que escriba una secuencia de numero del 1 al 50 

1:50 

# el resultado nos dice que posicin ocupa cada numero dentro de la secuencia.

2:50

# Podemos hacer operaciones matematicas con los vectores, se ejecutara segn el 
# orden de los elementos dentro del vector

c(1,2,3,4) + (10,20,30,40)

c(1,2,3,4) * (10,20,30,40)

c(1,2,3,4) - (1, 1, 1, 1)

c(1,2,3,4) / (10,20,30,40)

# Podemos sumar/multiplicar/dividir.
# Lo que queramos, un mismo numero al un vector

c(10, 20, 30, 40) + 1
c(10, 20, 30, 40) * 2
c(10, 20, 30, 40) / 2
c(10, 20, 30, 40) ^ 2 # elevar a un exponente

2/ c(10, 20, 30, 40)

# pero mirad que ocurre si no tienen la misma longitud

c(1,2,3,4,5) + c(10, 100)

# Escribir texto o "character"

"Me gusta R"

c("Me gusta R", "voy a aprender mucho")

c("Julia", "Alejandro", "Ruben")

# Cualquier cosa que tenga el simbolo de almohadilla ("#") delante es ignorado  

# Esto nos permite hacer comentarios al principio de una linea
1 + 2 + # o en el medio de un operacin
  + 3
[1] 6

#########################
#        OBJETOS
#########################

# En R podemos asignar valores a variables, tambien llamadas objetos. 
# Para asignar un valor a un objeto utilizamos este simbolo <-

x <- 3
y <- 2

# estos objetos quedan almacenados en R
# si escribimos x (llamamos a x)
x

x+y 
z <- x+y
z

# si ahora y cambia
y 
y <- 10 

# si llamamos al objeto z, vemos que no cambia de valor, porque "z" se gener 
# antes de que "y" cambiara de valor
z
# si ahora volvemos a asignar un valor z
z <- x+ y

# podemos asignar al objeto z un vector de longitud 2 (es decir con 2 elementos)
# conformado por x e y 
z <- c(x, y)

##llamamos a z

#generamos este vector largo

b <- c(1,2,3,4,5,6,7,8,9,10,11,12)
b

#podemos seleccionar un elemento dentro del vector

b[1]
b[8]
b[1:4] #podemos seleccionar un fragmento o rango dentro del vector b

# ejemplos ms complicados de operaciones con vectores los veremos en el Tema 3.

#########################
#           FUNCIONES
#########################

# En R, las funciones hacen el trabajo por nosotros. Ya hemos utilizado algunas,
# por ejemplo cuando hemos construido un vector anteponiendo c(...)
# Veamos otras funciones tiles. 
# Normalmente las funciones las encontramos en la forma f(arg1, arg2,...) donde 
# f sera el nombre de la funcin
# y arg1 arg2 los argumentos de la funcin


cos(234)

log2(1)

log2(2)

log(x=64, base=4)

log(64,4)

sqrt(4)

sum(17,2)

# pero no siempre las funciones tienen esta forma de f(...)
# ejemplo

17+2
2^3
3==4 ## esto es muy til para hacer comparaciones (significa "igual")
3!=4 ## esto es muy til para hacer comparaciones (significa "no es igual")
3!=3 ## esto es muy til

# Podemos utilizar "=" para asignar o "<-"
# Podemos utilizar "==" o "!=" para comparar y falsificar.
# Te devuelve un vector TRUE o FALSE



