################################################################################

#  Taller GBIF.ES: Manejo, visualizacin y anlisis de datos en ecologa con R
# Code by: Julia Chacn Labella
# Date: November 2018
# email: chacon.julia@inia.es

################################################################################


###################################
#          Descarga de paquetes
###################################

# Un paquete es una coleccin de funciones (que guardan relacin entre s) 
# elaboradas por alguien, 
# contienen ficheros de ayuda y archivos de datos.
# Podemos descargarlas. R ofrece una variedad enorme de paquetes
# para elaborar grficos interesantes como "ggplot2"
# para anlisis estadsitico, modelizacin...
# Algunos paquetes ya estn cargados en R, una vez que instalamos el programa
# otras veces tenemos que descargarlos nosotros a proposito 
# desde un repositorio publico.
# Tambien existe la opcin de construir tus propios paquetes de funciones..


# Funciones interesantes: 
(.packages()) # te da una lista de los paquetes cargados en este momento

(.packages(all.available=TRUE)) # te devuelve la lista de paquetes disponibles

library()  # te devuelve la lista de paquetes disponibles, 

? require accedemos a la ayuda de require

# Para instalar paquetes que no estn disponibles en nuestra lista 
library (ggplot2)  #  no funciona porque no est en nuestra lista de paquetes disponibles
library() # lo comprobamos
install.packages(c("ggplot2")) # los instala
library() # ahora debera aparecer
library (ggplot2)  #  ahora lo podemos cargar
remove.packages(c("ggplot2"),.Library) # los elimina de la lista
library() # ahora no debera aparecer

# Podemos hacer todo esto utilizando los botones disponibles en la consola, 
# sin comandos. Lo vemos en el video.