################################################################################

#  Taller GBIF.ES: Manejo, visualizacin y anlisis de datos en ecologa con R
# Code by: Julia Chacn Labella
# Date: November 2018
# email: chacon.julia@inia.es
# Tema 2: Manejo de Directorios

################################################################################

###################################
# CAMBIOS EN LOS DIRECTORIOS DE TRABAJO
###################################
getwd() #consultar por el directorio de trabajo
setwd() #cambio en el directorio de trabajo

###################################
# lectura de datos en R
###################################
# enlace interesante en Cran
# https://cran.r-project.org/doc/manuals/R-data.html
###################################

# 1) IMPORTAR DATOS A MANO CONSTRUYENDO VECTORES

salary <- c(18700000,14626720,14137500,13980000,12916666)
position <- c("QB","QB","DE","QB","QB")
team <- c("Colts","Patriots","Panthers","Bengals","Giants")
name.last <- c("Manning","Brady","Pepper","Palmer","Manning")
name.first <- c("Peyton","Tom","Julius","Carson","Eli") 

#contruccin de un arreglo de datos a partir de vectores
salarios <- data.frame(name.last,name.first,team,position,salary)
salarios

ls() #lista de objetos
ls(pattern = "sala") #buscar por un patron
rm(list=ls()[4]) #eliminar de la lista

#contruccin de un arreglo de datos a partir de vectores
salarios <- data.frame(name.last,name.first,team,position,salary)

## guardar esta sesin de R para seguir trabajando desde ella ms adelante
save.image("C:/Users/Julia/Desktop/CURSO R GBIF/TEMA 2/Tema2_JULIA.RData")

##
save(salarios, file="salarios.RData") 


# 2) IMPORTAR DATOS EN R DISPONIBLES EN R

data("iris") #cargar datos ya disponibles en R
iris
head(iris) #visualizar una parte de la tabla unicamente la parte de arriba

# 3) EXPORTAR UNA TABLA DE DATOS

# la funcin write.table
# write.table(iris, file = "iris.txt", append = FALSE, quote = TRUE, sep = " ",
  #          na = "NA", dec = ".", row.names = TRUE,
   #         col.names = TRUE)
# Consultar la ayuda
help("write.table")


write.table(iris, file="iris.txt")

ls()
rm(list=ls()[1])

# 4) LA FUNCION READ.TABLE IMPORTAR DATOS DESDE UN TXT

# data <- read.table("/nombre del directorio/Ejemplo 1.txt", header=T, sep="\t")
data <- read.table("iris.txt", header=T)
head(data)

iris <- data

# read.table puede fallar si hay espacios enrte los nombres de las variables
# o dentro de los niveles de un factor

# Para evitar esto, se deberian reemplazar todos los espacios de nombres por
#   '.' `o ' '.

# atencin a los argumentos de la funcin read.table
#OPCIONES:

data_excel <- read.table("clipboard", header=T)# haciendo copy-paste

# Funciones interesantes: 
ls()
# rm(list=ls())
names(data)
dim(data)
head(data)
tail(data)
colnames(data)
rownames(data) 



### 
#GUARDAR OBJETOS EN UN WORKSPACE o sesin de trabajo R
#save(x1,x2,...,file="fichero.RData") #comprobar antes el Working directory (WD)
#save.image(file="fichero.RData")

#CARGAR UNA SESION DE TRABAJO
load("Tema2_JULIA.RData")
#########


